##############################################################################
# ipmanage.tcl by ugly/LiV3D                                                 #
#                                                                            #
# CONFIGURATION:                                                             #
#                                                                            #
# The only thing you may need to change is the "set binary" in both "proc"   #
# blocks below.  Change /glftpd/bin/ipmanage.sh to the path of the script in #
# your bin dir.                                                              #
#                                                                            #
##############################################################################

bind msg - !ip msg:ip
bind msg - !keyip msg:keyip

proc msg:keyip {nick output binary text} {
 set binary {/glftpd/bin/ipmanage.sh}
 set user [lindex $text 0]
 set key [lindex $text 1]
 foreach line [split [exec $binary keyip $user $key] "\n"] {
   if { ! [info exists newline($line)] } { set newline($line) 0 } else { set newline($line) [expr $newline($line) + 1] }
   putserv "PRIVMSG $nick :$line\003$newline($line)"
 }
}

proc msg:ip {nick output binary text} { 
 set binary {/glftpd/bin/ipmanage.sh}
 set action [lindex $text 0]
 set user [lindex $text 1]
 set pass [lindex $text 2]
 set numip "0"
 if {[llength $text] > 3} {
   set numip [expr [llength $text] - 3]
 }
 for {set a 0} {$a < $numip} {incr a 1} {
 if {[lindex $text [expr $a + 3]] != ""} { set ip$a [lindex $text [expr $a + 3]] } 
 }
 switch $numip {
 0 { set output [exec $binary $action $user $pass] }
 1 { set output [exec $binary $action $user $pass $ip0] }
 2 { set output [exec $binary $action $user $pass $ip0 $ip1] }
 3 { set output [exec $binary $action $user $pass $ip0 $ip1 $ip2] }
 4 { set output [exec $binary $action $user $pass $ip0 $ip1 $ip2 $ip3] }
 5 { set output [exec $binary $action $user $pass $ip0 $ip1 $ip2 $ip3 $ip4] }
 6 { set output [exec $binary $action $user $pass $ip0 $ip1 $ip2 $ip3 $ip4 $ip5] }
 7 { set output [exec $binary $action $user $pass $ip0 $ip1 $ip2 $ip3 $ip4 $ip5 $ip6] }
 8 { set output [exec $binary $action $user $pass $ip0 $ip1 $ip2 $ip3 $ip4 $ip5 $ip6 $ip7] }
 9 { set output [exec $binary $action $user $pass $ip0 $ip1 $ip2 $ip3 $ip4 $ip5 $ip6 $ip7 $ip8] }
 10 { set output [exec $binary $action $user $pass $ip0 $ip1 $ip2 $ip3 $ip4 $ip5 $ip6 $ip7 $ip8 $ip9] }
}
if {$pass == "" && $action == "list"} {
  set output [exec $binary $action $user]
}
 putserv "PRIVMSG $nick :$output"
}

putlog "ipmanage by ugly/LiV3D loaded"
